﻿using System;
using System.Collections.Generic;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.Extensions.Hosting;
using MySystem;

public class PublicErrService : BackgroundService
{
    protected override async Task ExecuteAsync(CancellationToken stoppingToken)
    {
        while (!stoppingToken.IsCancellationRequested)
        {
            ProgressStart();
            await Task.Delay(5000);
        }
    }

    private void ProgressStart()
    {
        List<Brand> BrandList = RedisDbconn.Instance.GetList<Brand>("brand", 1, 1000);
        Parallel.ForEach(BrandList, brand =>
        {
            Dictionary<string, string> data = new Dictionary<string, string>();
            try
            { 
                data = RedisDbconn.Instance.RPop<Dictionary<string, string>>(brand.ReqType + "_err");
                RedisDbconn.Instance.AddList(brand.ReqType, data);
            }
            catch (Exception ex)
            {
                data.Add("TransferErr", ex.ToString());
                data.Add("TransferErrTime", DateTime.Now.ToString());
                RedisDbconn.Instance.AddList(brand.ReqType + "_service_err", data);
            }
        });
    }
}