using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using System.IO;
using Library;
using LitJson;

namespace MySystem.Areas.Api.Controllers
{
    public class HaoDaController : Admin.Controllers.BaseController
    {
        public HaoDaController(IHttpContextAccessor accessor, ILogger<Admin.Controllers.BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
        }



        #region 接收好哒订单通知
        [Route("/hd/notice/order")]
        public Dictionary<string, object> order()
        {
            StreamReader sr = new StreamReader(Request.Body);
            string requestMes = sr.ReadToEnd();
            if (string.IsNullOrEmpty(requestMes))
            {
                return new Dictionary<string, object>();
            }
            LogHelper.Instance.WriteLog(DateTime.Now.ToString() + "\n" + Newtonsoft.Json.JsonConvert.SerializeObject(Request.Headers) + "#cut#" + requestMes, "接收好哒好哒订单通知");
            RedisDbconn.Instance.AddList("cache:hd:notice:order", Newtonsoft.Json.JsonConvert.SerializeObject(Request.Headers) + "#cut#" + requestMes);
            Dictionary<string, object> obj = new Dictionary<string, object>();
            JsonData jsonObj = JsonMapper.ToObject(requestMes);
            obj.Add("recvOrdId", "RECV_ORD_ID_" + jsonObj["ordId"].ToString());
            obj.Add("resultCode", "0");
            return obj;
        }
        #endregion

        #region 接收好哒终端绑定商户通知
        [Route("/hd/notice/bind")]
        public Dictionary<string, object> bind()
        {
            StreamReader sr = new StreamReader(Request.Body);
            string requestMes = sr.ReadToEnd();
            if (string.IsNullOrEmpty(requestMes))
            {
                return new Dictionary<string, object>();
            }
            LogHelper.Instance.WriteLog(DateTime.Now.ToString() + "\n" + Newtonsoft.Json.JsonConvert.SerializeObject(Request.Headers) + "#cut#" + requestMes, "接收好哒终端绑定商户通知");
            RedisDbconn.Instance.AddList("cache:hd:notice:bind", Newtonsoft.Json.JsonConvert.SerializeObject(Request.Headers) + "#cut#" + requestMes);
            Dictionary<string, object> obj = new Dictionary<string, object>();
            // JsonData jsonObj = JsonMapper.ToObject(requestMes);
            obj.Add("resultCode", "0");
            return obj;
        }
        #endregion

        #region 接收好哒解绑终端通知
        [Route("/hd/notice/unbind")]
        public Dictionary<string, object> unbind()
        {
            StreamReader sr = new StreamReader(Request.Body);
            string requestMes = sr.ReadToEnd();
            if (string.IsNullOrEmpty(requestMes))
            {
                return new Dictionary<string, object>();
            }
            LogHelper.Instance.WriteLog(DateTime.Now.ToString() + "\n" + Newtonsoft.Json.JsonConvert.SerializeObject(Request.Headers) + "#cut#" + requestMes, "接收好哒解绑终端通知");
            RedisDbconn.Instance.AddList("cache:hd:notice:unbind", Newtonsoft.Json.JsonConvert.SerializeObject(Request.Headers) + "#cut#" + requestMes);
            Dictionary<string, object> obj = new Dictionary<string, object>();
            // JsonData jsonObj = JsonMapper.ToObject(requestMes);
            obj.Add("resultCode", "0");
            return obj;
        }
        #endregion

        #region 接收好哒替换终端通知接口
        [Route("/hd/notice/change")]
        public Dictionary<string, object> change()
        {
            StreamReader sr = new StreamReader(Request.Body);
            string requestMes = sr.ReadToEnd();
            if (string.IsNullOrEmpty(requestMes))
            {
                return new Dictionary<string, object>();
            }
            LogHelper.Instance.WriteLog(DateTime.Now.ToString() + "\n" + Newtonsoft.Json.JsonConvert.SerializeObject(Request.Headers) + "#cut#" + requestMes, "接收好哒替换终端通知接口");
            RedisDbconn.Instance.AddList("cache:hd:notice:change", Newtonsoft.Json.JsonConvert.SerializeObject(Request.Headers) + "#cut#" + requestMes);
            Dictionary<string, object> obj = new Dictionary<string, object>();
            // JsonData jsonObj = JsonMapper.ToObject(requestMes);
            obj.Add("resultCode", "0");
            return obj;
        }
        #endregion

        #region 接收好哒商户进件成功通知
        [Route("/hd/notice/merchant")]
        public Dictionary<string, object> merchant()
        {
            StreamReader sr = new StreamReader(Request.Body);
            string requestMes = sr.ReadToEnd();
            if (string.IsNullOrEmpty(requestMes))
            {
                return new Dictionary<string, object>();
            }
            LogHelper.Instance.WriteLog(DateTime.Now.ToString() + "\n" + Newtonsoft.Json.JsonConvert.SerializeObject(Request.Headers) + "#cut#" + requestMes, "接收好哒商户进件成功通知");
            RedisDbconn.Instance.AddList("cache:hd:notice:merchant", Newtonsoft.Json.JsonConvert.SerializeObject(Request.Headers) + "#cut#" + requestMes);
            Dictionary<string, object> obj = new Dictionary<string, object>();
            // JsonData jsonObj = JsonMapper.ToObject(requestMes);
            obj.Add("resultCode", "0");
            return obj;
        }
        #endregion

        #region 接收好哒押金通知
        [Route("/hd/notice/deposit")]
        public Dictionary<string, object> deposit()
        {
            StreamReader sr = new StreamReader(Request.Body);
            string requestMes = sr.ReadToEnd();
            if (string.IsNullOrEmpty(requestMes))
            {
                return new Dictionary<string, object>();
            }
            LogHelper.Instance.WriteLog(DateTime.Now.ToString() + "\n" + Newtonsoft.Json.JsonConvert.SerializeObject(Request.Headers) + "#cut#" + requestMes, "接收好哒押金通知");
            RedisDbconn.Instance.AddList("cache:hd:notice:deposit", Newtonsoft.Json.JsonConvert.SerializeObject(Request.Headers) + "#cut#" + requestMes);
            Dictionary<string, object> obj = new Dictionary<string, object>();
            // JsonData jsonObj = JsonMapper.ToObject(requestMes);
            obj.Add("resultCode", "0");
            return obj;
        }
        #endregion
    
    
    }
}