﻿using System.Collections.Generic;
using Library;

namespace AppConfig
{
    public class Base
    {
        public static string RdsSqlConn = Library.ConfigurationManager.AppSettings["RdsSqlConnStr"].ToString();

        public static string CreateTradeRecord = "SET NAMES utf8mb4;" +
                                                "SET FOREIGN_KEY_CHECKS = 0;" +
                                                "CREATE TABLE `TradeRecord#DateTime#` (" +
                                                "`Id` int(11) NOT NULL AUTO_INCREMENT," +
                                                "`Sort` int(11) NOT NULL DEFAULT '0'," +
                                                "`QueryCount` int(11) NOT NULL DEFAULT '0'," +
                                                "`Status` int(11) NOT NULL DEFAULT '0'," +
                                                "`CreateDate` datetime DEFAULT NULL," +
                                                "`UpdateDate` datetime DEFAULT NULL," +
                                                "`SeoTitle` varchar(100) DEFAULT NULL," +
                                                "`SeoKeyword` varchar(200) DEFAULT NULL," +
                                                "`SeoDescription` mediumtext," +
                                                "`ChannelSerial` varchar(50) DEFAULT NULL," +
                                                "`AgentNo` varchar(32) DEFAULT NULL," +
                                                "`ProductType` varchar(32) DEFAULT NULL," +
                                                "`Remark` varchar(64) DEFAULT NULL," +
                                                "`SettleMethod` varchar(16) DEFAULT NULL," +
                                                "`SettleFee` decimal(18,2) NOT NULL DEFAULT '0.00'," +
                                                "`BankCardNo` varchar(32) DEFAULT NULL," +
                                                "`ReceiptType` varchar(16) DEFAULT NULL," +
                                                "`IsStoreCashier` varchar(16) DEFAULT NULL," +
                                                "`DigAmt` decimal(18,2) NOT NULL DEFAULT '0.00'," +
                                                "`DigAmtFlag` varchar(4) DEFAULT NULL," +
                                                "`MerMobile` varchar(11) DEFAULT NULL," +
                                                "`DeviceType` varchar(16) DEFAULT NULL," +
                                                "`TradeSnNo` varchar(50) DEFAULT NULL," +
                                                "`BankCardType` varchar(16) DEFAULT NULL," +
                                                "`SerEntryMode` varchar(32) DEFAULT NULL," +
                                                "`TradeType` varchar(32) DEFAULT NULL," +
                                                "`TradeTime` varchar(8) DEFAULT NULL," +
                                                "`TradeDate` varchar(8) DEFAULT NULL," +
                                                "`ErrorMsg` varchar(32) DEFAULT NULL," +
                                                "`ErrorCode` varchar(16) DEFAULT NULL," +
                                                "`TradeStatus` varchar(16) DEFAULT NULL," +
                                                "`DiscountRateFlag` varchar(16) DEFAULT NULL," +
                                                "`BankAuthCode` varchar(32) DEFAULT NULL," +
                                                "`TradeReferNo` varchar(32) DEFAULT NULL," +
                                                "`TradeAmount` decimal(18,2) NOT NULL DEFAULT '0.00'," +
                                                "`MerName` varchar(50) DEFAULT NULL," +
                                                "`MerNo` varchar(50) DEFAULT NULL," +
                                                "`TradeSerialNo` varchar(100) DEFAULT NULL," +
                                                "`Field5` varchar(50) DEFAULT NULL," +
                                                "`Field4` varchar(50) DEFAULT NULL," +
                                                "`Field3` varchar(50) DEFAULT NULL," +
                                                "`Field2` varchar(50) DEFAULT NULL," +
                                                "`Field1` varchar(50) DEFAULT NULL," +
                                                "PRIMARY KEY (`Id`)," +
                                                "KEY `TradeRecordIndex` (`CreateDate`,`TradeSnNo`,`ProductType`,`MerNo`)" +
                                                ") ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;" +
                                                "SET FOREIGN_KEY_CHECKS = 1;";
    }
}